K1=100;
opt=1;   %10.15319585097904;
e=0.001;
M1=0;
for k=1:100
if(H_GSS(k,K1)>=opt-e)
M1=M1+1;
end
end
M1
M2=0;
for k=1:100
if(H_GSS_avg(k,K1)>=opt-e)
M2=M2+1;
end
end
M2
M3=0;
for k=1:100
if(H_EMSS(k,K1)>=opt-e)
M3=M3+1;
end
end
M3 



%---sphere-------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=10;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_sphere','H_GSS')
save('X_GSS_sphere','X_GSS')
save('H_a_GSS_sphere','H_GSS_a')
save('std_err_GSS_sphere','std_GSS')
save('S1_GSS_sphere','S1')
for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_sphere','H_CE')
save('X_CE_sphere','X_CE')
save('H_a_CE_sphere','H_CE_a')
save('std_err_CE_sphere','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_sphere','H_MRAS')
save('X_MRAS_sphere','X_MRAS')
save('H_a_MRAS_sphere','H_MRAS_a')
save('std_err_MRAS_sphere','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M); % annealing GASS
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_sphere','H_SA1')
save('X_SA1_sphere','X_SA1')
save('H_a_SA1_sphere','H_SA1_a')
save('std_err_SA1_sphere','std_SA1')
save('S2_GSS_sphere','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);  % geometric
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_sphere','H_SA2')
save('X_SA2_sphere','X_SA2')
save('H_a_SA2_sphere','H_SA2_a')
save('std_err_SA2_sphere','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);%lundy
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_sphere','H_SA3')
save('X_SA3_sphere','X_SA3')
save('H_a_SA3_sphere','H_SA3_a')
save('std_err_SA3_sphere','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M); %log 
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_sphere','H_SA4')
save('X_SA4_sphere','X_SA4')
save('H_a_SA4_sphere','H_SA4_a')
save('std_err_SA4_sphere','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_sphere','H_SA5')
save('X_SA5_sphere','X_SA5')
save('H_a_SA5_sphere','H_SA5_a')
save('std_err_SA5_sphere','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Sphere function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])



figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('50-D Sphere function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])

%--------------------trigonometric----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=2;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_tri','H_GSS')
save('X_GSS_tri','X_GSS')
save('H_a_GSS_tri','H_GSS_a')
save('std_err_GSS_tri','std_GSS')
save('S1_GSS_tri','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_tri','H_CE')
save('X_CE_tri','X_CE')
save('H_a_CE_tri','H_CE_a')
save('std_err_CE_tri','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_tri','H_MRAS')
save('X_MRAS_tri','X_MRAS')
save('H_a_MRAS_tri','H_MRAS_a')
save('std_err_MRAS_tri','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_tri','H_SA1')
save('X_SA1_tri','X_SA1')
save('H_a_SA1_tri','H_SA1_a')
save('std_err_SA1_tri','std_SA1')
save('S2_GSS_tri','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_tri','H_SA2')
save('X_SA2_tri','X_SA2')
save('H_a_SA2_tri','H_SA2_a')
save('std_err_SA2_tri','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_tri','H_SA3')
save('X_SA3_tri','X_SA3')
save('H_a_SA3_tri','H_SA3_a')
save('std_err_SA3_tri','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_tri','H_SA4')
save('X_SA4_tri','X_SA4')
save('H_a_SA4_tri','H_SA4_a')
save('std_err_SA4_tri','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_tri','H_SA5')
save('X_SA5_tri','X_SA5')
save('H_a_SA5_tri','H_SA5_a')
save('std_err_SA5_tri','std_SA5')

figure
semilogy(S2,-9.2985*ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Trigonometric function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','dist-GASS','MRAS','annealing-GASS','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(4) -8])


%--------------------griewank----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=3;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_griewank','H_GSS')
save('X_GSS_griewank','X_GSS')
save('H_a_GSS_griewank','H_GSS_a')
save('std_err_GSS_griewank','std_GSS')
save('S1_GSS_griewank','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_griewank','H_CE')
save('X_CE_griewank','X_CE')
save('H_a_CE_griewank','H_CE_a')
save('std_err_CE_griewank','std_CE')
for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_griewank','H_MRAS')
save('X_MRAS_griewank','X_MRAS')
save('H_a_MRAS_griewank','H_MRAS_a')
save('std_err_MRAS_griewank','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_griewank','H_SA1')
save('X_SA1_griewank','X_SA1')
save('H_a_SA1_griewank','H_SA1_a')
save('std_err_SA1_griewank','std_SA1')
save('S2_GSS_griewank','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_griewank','H_SA2')
save('X_SA2_griewank','X_SA2')
save('H_a_SA2_griewank','H_SA2_a')
save('std_err_SA2_griewank','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_griewank','H_SA3')
save('X_SA3_griewank','X_SA3')
save('H_a_SA3_griewank','H_SA3_a')
save('std_err_SA3_griewank','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_griewank','H_SA4')
save('X_SA4_griewank','X_SA4')
save('H_a_SA4_griewank','H_SA4_a')
save('std_err_SA4_griewank','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_griewank','H_SA5')
save('X_SA5_griewank','X_SA5')
save('H_a_SA5_griewank','H_SA5_a')
save('std_err_SA5_griewank','std_SA5')

figure
plot(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
plot(S1,H_GSS_a)
hold on
plot(S1,H_CE_a,':')
hold on
plot(S1,H_MRAS_a,'--')
hold on
plot(S2,H_SA1_a,'-.')
hold on
plot(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
plot(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
plot(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Griewank function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -2.5 -0.9])

figure
plot(S2,-zeros(1,length(S2)),'LineWidth',3)
hold on
plot(S1,H_GSS_a+1,'LineWidth',2)
hold on
plot(S1,H_MRAS_a+1,'--','LineWidth',2)
hold on
plot(S1,H_CE_a+1,':','LineWidth',2)
hold on
plot(S2(1:100:end),H_SA1_a(1:100:end)+1,'-o')
hold on
plot(S2(1:100:end),H_SA2_a(1:100:end)+1,'-+')
hold on
plot(S2(1:100:end),H_SA4_a(1:100:end)+1,'-*')
hold on
plot(S2(1:100:end),H_SA5_a(1:100:end)+1,'-s')
title('50-D Griewank function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -1.5 0.1])



%--------------------levy----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=7;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_levy','H_GSS')
save('X_GSS_levy','X_GSS')
save('H_a_GSS_levy','H_GSS_a')
save('std_err_GSS_levy','std_GSS')
save('S1_GSS_levy','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_levy','H_CE')
save('X_CE_levy','X_CE')
save('H_a_CE_levy','H_CE_a')
save('std_err_CE_levy','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_levy','H_MRAS')
save('X_MRAS_levy','X_MRAS')
save('H_a_MRAS_levy','H_MRAS_a')
save('std_err_MRAS_levy','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_levy','H_SA1')
save('X_SA1_levy','X_SA1')
save('H_a_SA1_levy','H_SA1_a')
save('std_err_SA1_levy','std_SA1')
save('S2_GSS_levy','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_levy','H_SA2')
save('X_SA2_levy','X_SA2')
save('H_a_SA2_levy','H_SA2_a')
save('std_err_SA2_levy','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_levy','H_SA3')
save('X_SA3_levy','X_SA3')
save('H_a_SA3_levy','H_SA3_a')
save('std_err_SA3_levy','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_levy','H_SA4')
save('X_SA4_levy','X_SA4')
save('H_a_SA4_levy','H_SA4_a')
save('std_err_SA4_levy','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_levy','H_SA5')
save('X_SA5_levy','X_SA5')
save('H_a_SA5_levy','H_SA5_a')
save('std_err_SA5_levy','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Levy function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(3) -10^(-0.2)])

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('50-D Levy function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(3) -10^(-0.2)])



%--------------------rastrigin----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=300; % number of maxmal iterations
choices=8;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_rastrigin','H_GSS')
save('X_GSS_rastrigin','X_GSS')
save('H_a_GSS_rastrigin','H_GSS_a')
save('std_err_GSS_rastrigin','std_GSS')
save('S1_GSS_rastrigin','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_rastrigin','H_CE')
save('X_CE_rastrigin','X_CE')
save('H_a_CE_rastrigin','H_CE_a')
save('std_err_CE_rastrigin','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_rastrigin','H_MRAS')
save('X_MRAS_rastrigin','X_MRAS')
save('H_a_MRAS_rastrigin','H_MRAS_a')
save('std_err_MRAS_rastrigin','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_rastrigin','H_SA1')
save('X_SA1_rastrigin','X_SA1')
save('H_a_SA1_rastrigin','H_SA1_a')
save('std_err_SA1_rastrigin','std_SA1')
save('S2_GSS_rastrigin','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_rastrigin','H_SA2')
save('X_SA2_rastrigin','X_SA2')
save('H_a_SA2_rastrigin','H_SA2_a')
save('std_err_SA2_rastrigin','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_rastrigin','H_SA3')
save('X_SA3_rastrigin','X_SA3')
save('H_a_SA3_rastrigin','H_SA3_a')
save('std_err_SA3_rastrigin','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_rastrigin','H_SA4')
save('X_SA4_rastrigin','X_SA4')
save('H_a_SA4_rastrigin','H_SA4_a')
save('std_err_SA4_rastrigin','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_rastrigin','H_SA5')
save('X_SA5_rastrigin','X_SA5')
save('H_a_SA5_rastrigin','H_SA5_a')
save('std_err_SA5_rastrigin','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Rastrigin function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(4) -10^(-0.2)])

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('50-D Rastrigin function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(4) -10^(-0.2)])



%--------------------powel----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=400; % number of maxmal iterations
choices=6;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_powel','H_GSS')
save('X_GSS_powel','X_GSS')
save('H_a_GSS_powel','H_GSS_a')
save('std_err_GSS_powel','std_GSS')
save('S1_GSS_powel','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_powel','H_CE')
save('X_CE_powel','X_CE')
save('H_a_CE_powel','H_CE_a')
save('std_err_CE_powel','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_powel','H_MRAS')
save('X_MRAS_powel','X_MRAS')
save('H_a_MRAS_powel','H_MRAS_a')
save('std_err_MRAS_powel','std_MRAS')

N=100;  % number of samples
K=4001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_powel','H_SA1')
save('X_SA1_powel','X_SA1')
save('H_a_SA1_powel','H_SA1_a')
save('std_err_SA1_powel','std_SA1')
save('S2_GSS_powel','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_powel','H_SA2')
save('X_SA2_powel','X_SA2')
save('H_a_SA2_powel','H_SA2_a')
save('std_err_SA2_powel','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_powel','H_SA3')
save('X_SA3_powel','X_SA3')
save('H_a_SA3_powel','H_SA3_a')
save('std_err_SA3_powel','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_powel','H_SA4')
save('X_SA4_powel','X_SA4')
save('H_a_SA4_powel','H_SA4_a')
save('std_err_SA4_powel','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_powel','H_SA5')
save('X_SA5_powel','X_SA5')
save('H_a_SA5_powel','H_SA5_a')
save('std_err_SA5_powel','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Powel function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(7) -10^(-0.2)])

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('50-D Powel function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(7) -10^(-0.2)])



%--------------------pinter----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=600; % number of maxmal iterations
choices=9;
M=50;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_pinter','H_GSS')
save('X_GSS_pinter','X_GSS')
save('H_a_GSS_pinter','H_GSS_a')
save('std_err_GSS_pinter','std_GSS')
save('S1_GSS_pinter','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_pinter','H_CE')
save('X_CE_pinter','X_CE')
save('H_a_CE_pinter','H_CE_a')
save('std_err_CE_pinter','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_pinter','H_MRAS')
save('X_MRAS_pinter','X_MRAS')
save('H_a_MRAS_pinter','H_MRAS_a')
save('std_err_MRAS_pinter','std_MRAS')

N=100;  % number of samples
K=6001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_pinter','H_SA1')
save('X_SA1_pinter','X_SA1')
save('H_a_SA1_pinter','H_SA1_a')
save('std_err_SA1_pinter','std_SA1')
save('S2_GSS_pinter','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_pinter','H_SA2')
save('X_SA2_pinter','X_SA2')
save('H_a_SA2_pinter','H_SA2_a')
save('std_err_SA2_pinter','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_pinter','H_SA3')
save('X_SA3_pinter','X_SA3')
save('H_a_SA3_pinter','H_SA3_a')
save('std_err_SA3_pinter','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_pinter','H_SA4')
save('X_SA4_pinter','X_SA4')
save('H_a_SA4_pinter','H_SA4_a')
save('std_err_SA4_pinter','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_pinter','H_SA5')
save('X_SA5_pinter','X_SA5')
save('H_a_SA5_pinter','H_SA5_a')
save('std_err_SA5_pinter','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('50-D Pinter function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('50-D Pinter function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])




%--------------------rosenbrock----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=200; % number of maxmal iterations
choices=1;
M=10;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_rosenbrock','H_GSS')
save('X_GSS_rosenbrock','X_GSS')
save('H_a_GSS_rosenbrock','H_GSS_a')
save('std_err_GSS_rosenbrock','std_GSS')
save('S1_GSS_rosenbrock','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_rosenbrock','H_CE')
save('X_CE_rosenbrock','X_CE')
save('H_a_CE_rosenbrock','H_CE_a')
save('std_err_CE_rosenbrock','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_rosenbrock','H_MRAS')
save('X_MRAS_rosenbrock','X_MRAS')
save('H_a_MRAS_rosenbrock','H_MRAS_a')
save('std_err_MRAS_rosenbrock','std_MRAS')

N=100;  % number of samples
K=2001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_rosenbrock','H_SA1')
save('X_SA1_rosenbrock','X_SA1')
save('H_a_SA1_rosenbrock','H_SA1_a')
save('std_err_SA1_rosenbrock','std_SA1')
save('S2_GSS_rosenbrock','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_rosenbrock','H_SA2')
save('X_SA2_rosenbrock','X_SA2')
save('H_a_SA2_rosenbrock','H_SA2_a')
save('std_err_SA2_rosenbrock','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_rosenbrock','H_SA3')
save('X_SA3_rosenbrock','X_SA3')
save('H_a_SA3_rosenbrock','H_SA3_a')
save('std_err_SA3_rosenbrock','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_rosenbrock','H_SA4')
save('X_SA4_rosenbrock','X_SA4')
save('H_a_SA4_rosenbrock','H_SA4_a')
save('std_err_SA4_rosenbrock','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_rosenbrock','H_SA5')
save('X_SA5_rosenbrock','X_SA5')
save('H_a_SA5_rosenbrock','H_SA5_a')
save('std_err_SA5_rosenbrock','std_SA5')

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',2)
hold on
semilogy(S1,H_GSS_a)
hold on
semilogy(S1,H_CE_a,':')
hold on
semilogy(S1,H_MRAS_a,'--')
hold on
semilogy(S2,H_SA1_a,'-.')
hold on
semilogy(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
semilogy(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
semilogy(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('10-D Rosenbrock function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])

figure
semilogy(S2,-ones(1,length(S2)),'LineWidth',3)
hold on
semilogy(S1,H_GSS_a,'LineWidth',2)
hold on
semilogy(S1,H_MRAS_a,'--','LineWidth',2)
hold on
semilogy(S1,H_CE_a,':','LineWidth',2)
hold on
semilogy(S2(1:100:end),H_SA1_a(1:100:end),'-o')
hold on
semilogy(S2(1:100:end),H_SA2_a(1:100:end),'-+')
hold on
semilogy(S2(1:100:end),H_SA4_a(1:100:end),'-*')
hold on
semilogy(S2(1:100:end),H_SA5_a(1:100:end),'-s')
title('10-D Rosenbrock function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S2(end) -10^(5) -10^(-0.2)])


%--------------------dejong5----------------
clear all;
warning off;
A=1;   %number of independent runs
N=1000;  % number of samples
K=50; % number of maxmal iterations
choices=5;
M=2;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
% save('H_GSS_dejong5','H_GSS')
% save('X_GSS_dejong5','X_GSS')
% save('H_a_GSS_dejong5','H_GSS_a')
% save('std_err_GSS_dejong5','std_GSS')
% save('S1_GSS_dejong5','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
% save('H_CE_dejong5','H_CE')
% save('X_CE_dejong5','X_CE')
% save('H_a_CE_dejong5','H_CE_a')
% save('std_err_CE_dejong5','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
% save('H_MRAS_dejong5','H_MRAS')
% save('X_MRAS_dejong5','X_MRAS')
% save('H_a_MRAS_dejong5','H_MRAS_a')
% save('std_err_MRAS_dejong5','std_MRAS')

N=100;  % number of samples
K=3001; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
% save('H_SA1_dejong5','H_SA1')
% save('X_SA1_dejong5','X_SA1')
% save('H_a_SA1_dejong5','H_SA1_a')
% save('std_err_SA1_dejong5','std_SA1')
% save('S2_GSS_dejong5','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
% save('H_SA2_dejong5','H_SA2')
% save('X_SA2_dejong5','X_SA2')
% save('H_a_SA2_dejong5','H_SA2_a')
% save('std_err_SA2_dejong5','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
% save('H_SA3_dejong5','H_SA3')
% save('X_SA3_dejong5','X_SA3')
% save('H_a_SA3_dejong5','H_SA3_a')
% save('std_err_SA3_dejong5','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
% save('H_SA4_dejong5','H_SA4')
% save('X_SA4_dejong5','X_SA4')
% save('H_a_SA4_dejong5','H_SA4_a')
% save('std_err_SA4_dejong5','std_SA4')

figure
plot(S1,-0.998*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GSS_a)
hold on
plot(S1,H_CE_a,':')
hold on
plot(S1,H_MRAS_a,'--')
hold on
plot(S2,H_SA1_a,'-.')
hold on
plot(S2(1:50:end),H_SA2_a(1:50:end),'-+')
hold on
plot(S2(1:50:end),H_SA4_a(1:50:end),'-*')
hold on
plot(S2(1:50:end),H_SA3_a(1:50:end),'-d')
title('2-D Dejong5 function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S1(end) -2 -0.8])



%--------------------shekel----------------
clear all;
warning off;
A=50;   %number of independent runs
N=1000;  % number of samples
K=80; % number of maxmal iterations
choices=4;
M=4;
for j=1:A
tic
[S1,H1,X1]=GASS_dis(N,K,choices,M);
disp(j)
H_GSS(j,:)=H1;
X_GSS(j,:)=X1(length(H1),:);
clear H1 X1;
toc
end
H_GSS_a=sum(H_GSS,1)/A;
std_GSS=std(H_GSS,0,1)/sqrt(A);
save('H_GSS_shekel','H_GSS')
save('X_GSS_shekel','X_GSS')
save('H_a_GSS_shekel','H_GSS_a')
save('std_err_GSS_shekel','std_GSS')
save('S1_GSS_shekel','S1')

for j=1:A
tic
[S1,H2,X2]=CE_dis(N,K,choices,M);
disp(j)
H_CE(j,:)=H2;
X_CE(j,:)=X2(length(H2),:);
clear H2 X2;
toc
end
H_CE_a=sum(H_CE,1)/A;
std_CE=std(H_CE,0,1)/sqrt(A);
save('H_CE_shekel','H_CE')
save('X_CE_shekel','X_CE')
save('H_a_CE_shekel','H_CE_a')
save('std_err_CE_shekel','std_CE')

for j=1:A
tic
[S1,H3,X3]=MRAS_dis(N,K,choices,M);
disp(j)
H_MRAS(j,:)=H3;
X_MRAS(j,:)=X3(length(H3),:);
clear H3 X3;
toc
end
H_MRAS_a=sum(H_MRAS,1)/A;
std_MRAS=std(H_MRAS,0,1)/sqrt(A);
save('H_MRAS_shekel','H_MRAS')
save('X_MRAS_shekel','X_MRAS')
save('H_a_MRAS_shekel','H_MRAS_a')
save('std_err_MRAS_shekel','std_MRAS')

N=100;  % number of samples
K=801; % number of maxmal iterations

for j=1:A
tic
[S2,H4,X4]=SA_dist(N,K,choices,M);
disp(j)
H_SA1(j,:)=H4;
X_SA1(j,:)=X4(length(H4),:);
clear H4 X4;
toc
end
H_SA1_a=sum(H_SA1,1)/A;
std_SA1=std(H_SA1,0,1)/sqrt(A);
save('H_SA1_shekel','H_SA1')
save('X_SA1_shekel','X_SA1')
save('H_a_SA1_shekel','H_SA1_a')
save('std_err_SA1_shekel','std_SA1')
save('S2_GSS_shekel','S2')

for j=1:A
tic
[S2,H5,X5]=SA_dist2(N,K,choices,M);
disp(j)
H_SA2(j,:)=H5;
X_SA2(j,:)=X5(length(H5),:);
clear H5 X5;
toc
end
H_SA2_a=sum(H_SA2,1)/A;
std_SA2=std(H_SA2,0,1)/sqrt(A);
save('H_SA2_shekel','H_SA2')
save('X_SA2_shekel','X_SA2')
save('H_a_SA2_shekel','H_SA2_a')
save('std_err_SA2_shekel','std_SA2')

for j=1:A
tic
[S2,H6,X6]=SA_dist3(N,K,choices,M);
disp(j)
H_SA3(j,:)=H6;
X_SA3(j,:)=X6(length(H6),:);
clear H6 X6;
toc
end
H_SA3_a=sum(H_SA3,1)/A;
std_SA3=std(H_SA3,0,1)/sqrt(A);
save('H_SA3_shekel','H_SA3')
save('X_SA3_shekel','X_SA3')
save('H_a_SA3_shekel','H_SA3_a')
save('std_err_SA3_shekel','std_SA3')

for j=1:A
tic
[S2,H7,X7]=SA_dist4(N,K,choices,M);
disp(j)
H_SA4(j,:)=H7;
X_SA4(j,:)=X7(length(H7),:);
clear H7 X7;
toc
end
H_SA4_a=sum(H_SA4,1)/A;
std_SA4=std(H_SA4,0,1)/sqrt(A);
save('H_SA4_shekel','H_SA4')
save('X_SA4_shekel','X_SA4')
save('H_a_SA4_shekel','H_SA4_a')
save('std_err_SA4_shekel','std_SA4')

for j=1:A
tic
[S2,H8,X8]=SA_dist5(N,K,choices,M); %adpative temperature 
disp(j)
H_SA5(j,:)=H8;
X_SA5(j,:)=X8(length(H8),:);
clear H8 X8;
toc
end
H_SA5_a=sum(H_SA5,1)/A;
std_SA5=std(H_SA5,0,1)/sqrt(A);
save('H_SA5_shekel','H_SA5')
save('X_SA5_shekel','X_SA5')
save('H_a_SA5_shekel','H_SA5_a')
save('std_err_SA5_shekel','std_SA5')

figure
plot(S1,10.153*ones(1,length(S1)),'LineWidth',2)
hold on
plot(S1,H_GSS_a)
hold on
plot(S1,H_CE_a,':')
hold on
plot(S1,H_MRAS_a,'--')
hold on
plot(S2,H_SA1_a,'-.')
hold on
plot(S2(1:10:end),H_SA2_a(1:10:end),'-+')
hold on
plot(S2(1:10:end),H_SA4_a(1:10:end),'-*')
hold on
plot(S2(1:10:end),H_SA3_a(1:10:end),'-d')
title('4-D Shekel function')
xlabel('Total sample size')
ylabel('Function value');
legend('true optimum','GASS','modified CE','MRAS','SA (Gradient Temp)','SA (Geometric Temp)','SA (log Temp)','SA (Lundy Temp)');
axis([0 S1(end) 0 10.5])


figure
plot(S1,10.153*ones(1,length(S1)),'LineWidth',3)
hold on
plot(S1,H_GSS_a,'LineWidth',2)
hold on
plot(S1,H_MRAS_a,'--','LineWidth',2)
hold on
plot(S1,H_CE_a,':','LineWidth',2)
hold on
plot(S2(1:20:end),H_SA1_a(1:20:end),'-o')
hold on
plot(S2(1:20:end),H_SA2_a(1:20:end),'-+')
hold on
plot(S2(1:20:end),H_SA4_a(1:20:end),'-*')
hold on
plot(S2(1:20:end),H_SA5_a(1:20:end),'-s')
title('4-D Shekel function')
xlabel('Total sample size')
ylabel('Function value');
legend('True Optimum','Dist-GASS','MRAS','CE','Annealing-GASS','SA (Geo Temp)','SA (Log Temp)','SA (Adap Temp)');
axis([0 S1(end) 0 10.5])